#!/usr/bin/env python


#***********************************************************************
# pysycache : a tool for learn to move mouse
# Copyright (C) 2005 Vincent DEROO (vincent.pysycache@free.fr)
#
# This tool is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#***********************************************************************



#*******************************************************************************
# Importation des modules
#*******************************************************************************
import sys
import getopt, string

import random, os
import pygame
from pygame.locals import *



#*******************************************************************************
#                                                                              #
#                                                                              #
#                                  Fonctions                                   #
#                                                                              #
#                                                                              #
#*******************************************************************************

#*******************************************************************************
# Affiche l'aide
#*******************************************************************************
def help_message():
	print '''
Options: 
    -h              : displays this help message
    -a              : expects an argument
    -f		        : fullscreen
    --fullscreen    : 
    --file=         : expects an argument
    --view          : doesn't necessarily expect an argument
    --version       : displays Python version'''
	sys.exit(0)






#*******************************************************************************
# Affichage de l'ecran
#*******************************************************************************
def DrawScreen():
	pygame.display.flip()
	



#*******************************************************************************
# Charge une image
#*******************************************************************************
def load_image(dirname, filename, colorkey=None):
	fullname = os.path.join(dirname, filename)
	try:
		image = pygame.image.load(fullname)
	except pygame.error, message:
		print 'Cannot load image:', fullname
		raise SystemExit, message
	image = image.convert()
	if colorkey is not None:
		if colorkey is -1:
			colorkey = image.get_at((0,0))
		image.set_colorkey(colorkey, RLEACCEL)

	return image, image.get_rect()




#*******************************************************************************
# Charge une image
#*******************************************************************************
def load_png(dirname, filename):
	""" Load image and return image object"""
	fullname = os.path.join(dirname, filename)
	try:
		image = pygame.image.load(fullname)
		if image.get_alpha is None:
			image = image.convert()
		else:
			image = image.convert_alpha()
	except pygame.error, message:
        	print 'Cannot load image:', fullname
        	raise SystemExit, message
	return image, image.get_rect()



