#!/usr/bin/env python

#***********************************************************************
# pysycache : a tool for learn to move mouse
# Copyright (C) 2005 Vincent DEROO (vincent.pysycache@free.fr)
#
# This tool is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#***********************************************************************



#*******************************************************************************
# Importation des modules
#*******************************************************************************
import sys
import getopt, string

import random, os
import pygame
from pygame.locals import *
import datas
import const
import glob





#*******************************************************************************
#                                                                              #
#                                                                              #
#                                   Classe                                     #
#                                                                              #
#                                                                              #
#*******************************************************************************

class BtnMenu(pygame.sprite.Sprite):
	"""This class is for the enemy ships"""
	def __init__(self, left, top, filename, id, btnsize):
		pygame.sprite.Sprite.__init__(self) #call Sprite intializer
		self.image, self.rect = datas.load_png('images', filename)
		self.rect.left = left
		self.rect.top = top 
		self.id = id
		self.btnsize = btnsize

class Carreau:
        numligne = 0
        numcol = 0
        etat = 0                #0 : cache
                                #1 : affiche



#*******************************************************************************
#                                                                              #
#                                                                              #
#                                  Fonctions                                   #
#                                                                              #
#                                                                              #
#*******************************************************************************


def InitialiseDessin(idxdirectory, imgcache, imgdessous):
	"""Initialize new picture """
        global Gimg_dessous
        const.GTabCarreau[:] = []   	#vider
					#tableau avec toutes les infos sur les lignes

        #initialisation des carres
        nblarg = 700 / const.GTailleLarg
        nbhaut = 600 / const.GTailleHaut
        const.GNbCarreau = nblarg * nbhaut      
        
        for i in range(nblarg):
            for j in range(nbhaut):
                car = Carreau()
                car.numligne = i
                car.numcol = j
                car.etat = 0
                const.GTabCarreau.append(car)
       
        #chargement du dessin
	directory = GLstThemes[idxdirectory]
        filename = os.path.join(directory, 'cache', imgcache)               
        img_dessus, background_rect = datas.load_image('datas', filename)
        screen = pygame.display.get_surface()  
        screen.blit(img_dessus, (0, 0))
        filename = os.path.join(directory, imgdessous)               
        Gimg_dessous, background_rect = datas.load_image('datas', filename)



#*******************************************************************************
#
#*******************************************************************************
def GetTailleCarreau(idxtaille):
	"""Get the size of a tile by level """
	if idxtaille == 0:
	        const.GTailleLarg = 100
	        const.GTailleHaut = 100
	elif idxtaille == 1:
	        const.GTailleLarg = 70
	        const.GTailleHaut = 60
	elif idxtaille ==2:
	        const.GTailleLarg = 50
	        const.GTailleHaut = 50




#*******************************************************************************
# change le logo du theme 
#  (a partir des repertoires)
#*******************************************************************************
def ChangeLogo():
	""" Change logo of a theme """
	if const.GIdxThemes == 999999:
		#tous les themes
		filename = os.path.join('images', 'logo.png')
	else:
		#un theme particulier
		filename = os.path.join('datas', GLstThemes[const.GIdxThemes], 'logo.png')

	if os.path.isfile(filename) == True:
	    	imgtmp = pygame.image.load(filename)
	else:
		filename = os.path.join('images', 'logo.png')
	    	imgtmp = pygame.image.load(filename)


	#mise a jour de l'image du theme
	for obj2 in LstBtn.sprites():
		if obj2.id == 5:
			screen = pygame.display.get_surface()
			screen.blit(Gbackground_image, (obj2.rect.left, obj2.rect.top), (0, 0, 96, 96))
			obj2.image.blit(imgtmp, (obj2.rect.left, obj2.rect.top), (0, 0, 96, 96))
			obj2.image = imgtmp




#*******************************************************************************
# charge les images d'un repertoire
#*******************************************************************************
def LoadListImage(themename):
	""" Find all pictures of a directoy """

	#---------------------- images normales ----------------------------
    	filtre = os.path.join('datas', themename, 'a*.jpeg') 
	#vider		
	GLstImage[:] = [] 
	GLstImgCache[:] = [] 
	#remplir
	for nom in glob.glob(filtre):
		if os.path.isfile(nom):
			(filepath, filename) = os.path.split(nom) 
			GLstImage.append(filename)
			GLstImgCache.append('b' + filename.strip('a'))




#*******************************************************************************
# Detection des evenements
#
#
#	self.listenKeys = { K_UP: self.MoveUp,
#	                    K_DOWN: self.MoveDown,
#	                    K_LEFT: self.SetVelocityLeft,
#	                    K_RIGHT: self.SetVelocityRight,
#	                    K_SPACE: self.MoveUp
#	                  }
#
#
#*******************************************************************************
def DetectEvent():
	""" """
	if const.GModeJeu == 3:
		return 1

	for event in pygame.event.get():
		if event.type == QUIT:
			return 0
		elif event.type == KEYUP:
			if event.key == K_ESCAPE:
				return 0
		elif event.type == pygame.MOUSEMOTION:
            	    #verifions que la souris est sur la bonne zone de l'image
            	    
                    #------------ decouverte image ---------------
                    # les images doivent faire 700 x 600 
                    # car il n'y a aucun recadrage

                    if const.GModeJeu == 0:
                        #on est en mode jeu
                   	caseleft = int( (event.pos[0] ) / const.GTailleLarg )
	                casetop = int( (event.pos[1] ) / const.GTailleHaut )
                    	nouveauleft = caseleft * const.GTailleLarg
                    	nouveautop = casetop * const.GTailleHaut

                        #recherche si deja coche
                        for car in const.GTabCarreau:
                       		if (car.numligne == caseleft) & (car.numcol == casetop):
                               		if car.etat == 0:
	                                    tr = pygame.Rect([nouveauleft , nouveautop, const.GTailleLarg, const.GTailleHaut] )
	                                    screen = pygame.display.get_surface()       
	                                    screen.blit(Gimg_dessous, [nouveauleft, nouveautop], tr )
	                                    car.etat = 1
	                                    const.GNbCarreau = const.GNbCarreau - 1
					break
			return 1
		elif event.type == MOUSEBUTTONDOWN:
			ok = 0

                        #recherche du bouton concerne
             		for obj in LstBtn.sprites() :
              			if ( event.pos[0] >= obj.rect.left ) & ( event.pos[0] <= obj.rect.left + obj.btnsize ) & ( event.pos[1] >= obj.rect.top  ) & ( event.pos[1] <= obj.rect.top + obj.btnsize ) :
                                	#----------- show the correct window -----------------
               				if ( obj.id == 1 ) :
               				    	#Option heure
					    	wingames.ShowWinGames(0)
					if ( obj.id == 2) :
					    	#Quitter
						return 0
					if ( obj.id == 3) :
					    	#image avant (dans le theme)
						if const.GIdxImage > 0:
							const.GIdxImage = const.GIdxImage - 1
						else:
							const.GIdxImage = len(GLstImage) - 1
						ok = 1
					if ( obj.id == 4) :
					    	#image apres (dans le theme)
						if const.GIdxImage < len(GLstImage) - 1:
							const.GIdxImage = const.GIdxImage + 1
						else:
							const.GIdxImage = 0
						ok = 1
					if ( obj.id == 5) :
						#image du theme
						const.GIdxThemes = const.GIdxThemes + 1
						if const.GIdxThemes >= len(GLstThemes):
							const.GIdxThemes = 0
						LoadListImage(GLstThemes[const.GIdxThemes])
						const.GIdxImage = 0
						ChangeLogo()
						ok = 1
					if ( obj.id == 6) :
						#taille carreau
						const.GTailleCarreau = const.GTailleCarreau + 1
						if const.GTailleCarreau == 3:
							const.GTailleCarreau = 0
						if const.GTailleCarreau == 0:
							filename = os.path.join('images', 'btn-size1.png')
						elif const.GTailleCarreau == 1:
							filename = os.path.join('images', 'btn-size2.png')
						else:
							filename = os.path.join('images', 'btn-size3.png')
					    	imgtmp = pygame.image.load(filename)

						#mise a jour image taille carreau
						screen = pygame.display.get_surface()
						screen.blit(Gbackground_image, (obj.rect.left, obj.rect.top), (0, 0, 96, 96))
						obj.image.blit(imgtmp, (obj.rect.left, obj.rect.top), (0, 0, 96, 96))
						obj.image = imgtmp
						ok = 1
			
                                	#----------- update the picture -----------------
					if ok == 1:
						const.GModeJeu = 3
						pygame.mouse.set_visible(0)  #invisible
						GetTailleCarreau(const.GTailleCarreau)
						InitialiseDessin(const.GIdxThemes, GLstImgCache[const.GIdxImage], GLstImage[const.GIdxImage])
						pygame.mouse.set_visible(1)  #visible
						const.GModeJeu = 0

			return 1
	return 1





#*******************************************************************************
# boucle principale
# si typfull = 0 : mode fenetre
#            = 1 : mode plein ecran
#*******************************************************************************
def main(typfull):
	global GMaSouris
	global Gbackground_image
	global GMaSouris_position
	global GLstThemes   	#themes des images
				#est obtenue a partir du repertoire datas    
	global GLstImage	#liste d'image a decouvrir du repertoire de theme
	global GLstImgCache	#liste d'image qui cache du repertoire de theme
   

	#----------------------  Initialise screen -------------------------
	pygame.init()

	#----------------------  Initialise son -------------------------

	try:
		pygame.mixer.init()
		snd = 1
	except:
		snd = None

	#musique de fond
#	music = os.path.join('music', 'jinglebells.mod')
#	pygame.mixer.music.load(os.path.join(music))
#	pygame.mixer.music.play(-1)



	const.GModeJeu = 3
	
	pygame.mouse.set_pos((720, 20))
	pygame.mouse.set_visible(0)  #cache

        screen = pygame.display.set_mode((800, 600))
	if typfull != 0:
	    pygame.display.toggle_fullscreen()
#    	    screen = pygame.display.set_mode((800, 600))
#	else:
#	    screen = pygame.display.set_mode((800, 600), FULLSCREEN)
	pygame.display.set_caption('PySyCache')

	pygame.mouse.set_pos((720, 20))

	#------------------- changer la souris en main -------------------
	filename = os.path.join('images', 'souris.xbm')
	maskname = os.path.join('images', 'souris-mask.xbm')
	cursor = pygame.cursors.load_xbm(filename, maskname)
	cursor = cursor[0], (cursor[0][0] / 2, cursor[0][1] / 2), cursor[2], cursor[3]
	pygame.mouse.set_cursor(cursor[0], (0, 0), cursor[2], cursor[3])

	#----------------------- image vide de fond -------------------------
	background_image, background_rect = datas.load_image('images', 'fond1.bmp')
	screen.blit(background_image, (0,0))
	datas.DrawScreen()
	
	#attende de 2 secondes
	pygame.time.delay(2000)
	
	#-------------- transition vers le titre du jeu ---------------------
	background_image2, background_rect = datas.load_image('images', 'fond2.bmp')
        for i in range(300):
            screen.blit(background_image2, (0, i), (0, i, 800, 1))
            screen.blit(background_image2, (0, 600 - i), (0, 600 - i, 800, 1))
            datas.DrawScreen()
            pygame.time.wait(10)               
	screen.blit(background_image2, (0,0))
	datas.DrawScreen()
	
	#attende de 4 secondes
	pygame.time.delay(4000)
	
	#------------------ transition vers le jeu ------------------------
	Gbackground_image, background_rect = datas.load_image('images', 'fond3.bmp')
        for i in range(300):
            screen.blit(Gbackground_image, (0, i), (0, i, 800, 1))
            screen.blit(Gbackground_image, (0, 600 - i), (0, 600 - i, 800, 1))
            datas.DrawScreen()
            pygame.time.wait(10) 
	screen.blit(Gbackground_image, (0,0))
	datas.DrawScreen()
	
	#-------------------- liste des boutons ----------------------
	global LstBtn
	LstBtn = pygame.sprite.RenderClear()
	#horloge - timer
#	LstBtn.add(BtnMenu(702, 10, 'btn-horloge.png', 1, 96))

	#indicateur de taille des carreaux
	LstBtn.add(BtnMenu(705, 110, 'btn-size2.png', 6, 96))

	#image du theme
	LstBtn.add(BtnMenu(702, 300, 'logo.png', 5, 96))

	#avant et apres
	LstBtn.add(BtnMenu(705, 410, 'btn-avant.png', 3, 48))
	LstBtn.add(BtnMenu(755, 410, 'btn-apres.png', 4, 48))
	
	#aide
#	LstBtn.add(BtnMenu(228, 470, 'btn-main-03.png', 3))
	#credit
#	LstBtn.add(BtnMenu(478, 500, 'btn-main-04.png', 4))
	#quitter
	LstBtn.add(BtnMenu(702, 502, 'btn-quitter.png', 2, 96))
	
	
	#---------------- rechercher les themes disponibles ----------------------
    	repertoire = os.path.join('datas')
	GLstThemes = []
	GLstImage = []
	GLstImgCache = []
	const.GIdxThemes = 0		#par defaut le theme numero 1
    	for nom in os.listdir(repertoire):
		#ne prendre que les repertoires
		isrep = os.path.join('datas', nom)
		if os.path.isdir(isrep):
			GLstThemes.append(nom)

	const.GIdxThemes = 0
	const.GIdxImage = 0

	#---------------- rechercher les images d'un theme ----------------------
	LoadListImage(GLstThemes[const.GIdxThemes])

	ChangeLogo()

        #-------------- taille des carres --------------
	const.GTailleCarreau = 1
	GetTailleCarreau(const.GTailleCarreau)

        #-------------- affichage du dessin --------------
        InitialiseDessin(const.GIdxThemes, GLstImgCache[const.GIdxImage], GLstImage[const.GIdxImage])
	pygame.mouse.set_visible(1)  #visible
	const.GModeJeu = 0

        #-------------- entree dans la boucle principale --------------
	running = 1
	while running:
	    pygame.time.delay(2)
#	    clock.tick(60)
	
	    #recherche des evt
	    running = DetectEvent()

       	    #verification si on a tout decouvert
            if const.GNbCarreau == 0:
	       	const.GModeJeu = 1           #on passe en mode gagne
		pygame.mouse.set_pos((720, 20))
		pygame.mouse.set_visible(0)    #cache
	       	datas.DrawScreen()


	    	#attende de 2 secondes
	    	pygame.time.wait(1000)

		#on est en mode gagne
	       	imggagne, imgfin_rect = datas.load_png('images', 'gagne.png')
	       	screen = pygame.display.get_surface()       
	       	screen.blit(imggagne, (100, 40))
	       	datas.DrawScreen()

	    	#attende de 2 secondes
	    	pygame.time.wait(2000)
                            
	    	#on recharge une nouvelle image
		const.GIdxImage = const.GIdxImage + 1
		if const.GIdxImage >= len(GLstImage):
			const.GIdxImage = 0
		GetTailleCarreau(const.GTailleCarreau)
		InitialiseDessin(const.GIdxThemes, GLstImgCache[const.GIdxImage], GLstImage[const.GIdxImage])
		pygame.mouse.set_visible(1)  #visible
		const.GModeJeu = 0

	    LstBtn.draw(screen)	
	    datas.DrawScreen()

	pygame.mouse.set_visible(0)

	#Game is finnished : showcredits
	Gbackground_image, background_rect = datas.load_image('images', 'fond4.bmp')
        for i in range(300):
            screen.blit(Gbackground_image, (0, i), (0, i, 800, 1))
            screen.blit(Gbackground_image, (0, 600 - i), (0, 600 - i, 800, 1))
            datas.DrawScreen()
            pygame.time.wait(10)               
	screen.blit(Gbackground_image, (0,0))
	datas.DrawScreen()


        #attende de 2 secondes
        pygame.time.delay(2000)
      
        #------------------ affichage des credits ------------------------
        font = pygame.font.Font(None, 80)
        textcolor = 50, 50, 220
        
	#credits auteur
	fichier = os.path.join('credits.txt')
	if os.path.isfile(fichier):
		#afficher le contenu 
		f = open(fichier, 'r')
	        lignes  = f.readlines()
		cptligne = 0;
	        for j in lignes:
			j = j.strip()
	   		text = font.render(j, 1, textcolor)
	            	screen.blit(text, (40, 60 + 50 * cptligne))      
			cptligne = cptligne + 1
			datas.DrawScreen()
		f.close()
		pygame.time.wait(5000) 


	#credit images
    	repertoire = os.path.join('datas')
    	for nom in os.listdir(repertoire):
		#ne prendre que les repertoires
		isrep = os.path.join('datas', nom)
		if os.path.isdir(isrep):
			fichier = os.path.join('datas', nom, 'credits.txt')
			if os.path.isfile(fichier):
				screen.blit(Gbackground_image, (0,0))
				datas.DrawScreen()
				#afficher le contenu 
				f = open(fichier, 'r')
			        lignes  = f.readlines()
				cptligne = 0;
			        for j in lignes:
         				j = j.strip()
			   		text = font.render(j, 1, textcolor)
			            	screen.blit(text, (40, 60 + 50 * cptligne))      
            				cptligne = cptligne + 1
	    				datas.DrawScreen()
        			f.close()
        			pygame.time.wait(5000) 










#*******************************************************************************
# Programme principal
#*******************************************************************************

	
	
#valeur par defaut
typfen = 1	

# analyse des parametres passes en arguement
for opt in sys.argv:
    if opt == '-nf':
        typfen = 0
    if opt == '--nofullscreen':
        typfen = 0
            
    if opt == '-h':
        help_message()
            
    if opt == '--version':
        print 'pysycache version 1.0'
        sys.exit(0)
    if opt == '--python-version':
        print 'Python '+sys.version
        sys.exit(0)



#lancement de la boucle principale
if __name__ == '__main__': main(typfen)


